<template>
  <page>
    <a-form
      v-if="!fetching"
      @submit="handleSubmit"
    >
      <h2>Logotipo atual:</h2>
      <img
        v-if="currentLogo"
        :src="currentLogo"
        alt="Logotipo do Instituto Holístico"
        class="logo"
      >

      <p v-else>O sistema não possui logotipo cadastrado</p>

      <h1 class="form-title">
        Editar logotipo:
      </h1>

      <a-form-item
        label="Envie a imagem para atualizar o logotipo:"
        class="input-icon"
        required="true"
      >
        <a-upload-dragger
          :file-list="fileList"
          :remove="handleRemove"
          :before-upload="beforeUpload"
        >
          <p class="ant-upload-drag-icon">
            <a-icon type="inbox" />
          </p>
          <p class="ant-upload-text">
            Clique ou arraste a foto para essa área
          </p>
        </a-upload-dragger>

        <a-form-item>
          <a-button
            html-type="submit"
            type="primary"
            class="submit-button"
            :disabled="uploading"
          >
            <span v-if="uploading">
              <a-icon type="loading" />
            </span>
            <span v-else>Enviar</span>
          </a-button>
        </a-form-item>
      </a-form-item>
    </a-form>

    <page-loading v-if="fetching" />
  </page>
</template>

<script>
import uploadDragger from '@/mixins/upload-dragger';

export default {
  name: 'EditLogo',
  mixins: [uploadDragger],
  data() {
    return {
      currentLogo: '',
      uploading: false,
      fetching: false,
    };
  },
  async created() {
    try {
      this.fetching = true;
      const fetch = await this.$http.get('/headers');
      this.currentLogo = fetch.data[0].logo;
      this.fetching = false;
    } catch (error) {
      this.fetching = false;
      this.$message.error('Ocorreu um erro ao buscar o logotipo. Tente novamente mais tarde.');
    }
  },
  methods: {
    async handleSubmit(e) {
      e.preventDefault();

      if (this.checkFields()) {
        try {
          this.uploading = true;

          const formData = this.createFormData();
          const fetch = await this.$http.post('/headers', formData);

          this.$message.success('Logotipo trocado com sucesso.');
          this.$message.success('Atualize a página para visualizar a mudança completamente.');

          this.currentLogo = fetch.logo;

          this.clearFields();
          this.uploading = false;
        } catch (error) {
          this.uploading = false;
          this.$message.error('Houve uma falha ao trocar o logotipo.');
        }
      } else {
        this.$message.error('Por favor preencha todos os campos obrigatórios!');
      }
    },
    checkFields() {
      return this.checkFileList();
    },
    createFormData() {
      const formData = new FormData();

      formData.append('image', this.fileList[0]);

      return formData;
    },
    clearFields() {
      this.fileList = [];
    },
  },
};
</script>

<style lang="stylus" scoped>
.form-title
  margin-top 4rem

.logo
  width 10rem

.submit-button
  float right
  margin-top 2rem
</style>
